#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "grader.h"

#define SECRET "ygkomplqmjuxvpfo"

static int H[5000][200];
static int V[5000][200];

int _main(initFunction init, changeHFunction changeH, changeVFunction changeV, escapeFunction escape) {
	int R, C, E, P, Q, W, V1, V2, event, i, j;

	assert(scanf("%d%d", &R, &C) == 2);
    for (i = 0; i < R; ++i)
        for (j = 0; j < C-1; ++j)
            assert(scanf("%d", &H[i][j]) == 1);
    for (i = 0; i < R-1; ++i)
        for (j = 0; j < C; ++j)
            assert(scanf("%d", &V[i][j]) == 1);

    init(R, C, H, V);

	assert(scanf("%d", &E) == 1);
	for (i = 0; i < E; i++) {
		assert(scanf("%d", &event) == 1);
        if (event == 1) {
            assert(scanf("%d%d%d", &P, &Q, &W) == 3);
            changeH(P, Q, W);
        } else if (event == 2) {
            assert(scanf("%d%d%d", &P, &Q, &W) == 3);
            changeV(P, Q, W);
        } else if (event == 3) {
            assert(scanf("%d%d", &V1, &V2) == 2);
            printf("%s %d\n", SECRET, escape(V1, V2));
        } 
	}

	return 0;
}
